
/*
	Copy the values of w corresponding to the boundary
	South (ib==1), East (ib==2), North (ib==3), West (ib==4)
	onto s 
	
	IN:	ib	define piece of boundary
		nx, ny  number of lines in x/y direction
		w	vector
	OUT:	s	vector of boundary values
*/
	
void GetBound(ib,nx,ny,w,s)
int nx,ny,ib;
double w[][2], s[][2];
{
  int i,j,iediag,iehor;
 
  iediag = (nx-1) * (ny-1)-1;
  iehor = (nx-1)*(ny-1) + (nx-1)*ny - 1;
  switch (ib)
    {
    case 1:
      {
	for (i=0; i<nx-1; i++)
	  for(j=0;j<2;j++) s[i][j] = w[iediag+i+1][j];
 	break;
      }
    case 3:
      {  
	for (i=0; i<nx-1; i++)
	  for(j=0;j<2;j++)  s[i][j] = w[iehor-nx+i+2][j];
 	break;
      }
    case 4:
      {
	for (i=0; i<ny-1; i++)
	  for(j=0;j<2;j++) s[i][j]   = w[iehor + 1 + i*nx][j]; 
  	break;
      }
    case 2:
      { 
	for (i=0; i<ny-1; i++)
	  for(j=0;j<2;j++) s[i][j]   = w[iehor+nx+i*nx][j];
  	break;
      }
    default:
      ;
    }
  return;     
}

 

 
