/*  Apply b.c. defined in u on matrix and right hand side	*/
/*  via penalty method. 					*/

void ApplyDirichletBC(nx, ny, neigh, u, sk, id, ik, f)
int    nx, ny, neigh[4], id[], ik[];
double u[], sk[], f[];
{
  double penalty=1e6;
  int    i,j,k,start[4],end[4],step[4],dx,dy,tl,tr,bl,br,id1;
 
  dx = 1;
  dy = nx+1;
  bl  = 0;
  br  = nx;
  tl  = ny*(nx+1);
  tr  = (ny+1)*(nx+1)-1; 
  start[0] = bl;  end[0] = br;  step[0] = dx;
  start[1] = br;  end[1] = tr;  step[1] = dy;
  start[2] = tl;  end[2] = tr;  step[2] = dx;
  start[3] = bl;  end[3] = tl;  step[3] = dy;
  
  for (j=0; j<4; j++)
  {
    if (neigh[j]<0)
    {
      for (i=start[j]; i<=end[j]; i += step[j])
      {
	id1 = (i==0) ? 0 : id[i-1]+1;
	sk[id1] = penalty;		/* matrix weighted scaling feasible */
	f[i] = penalty*u[i];
      }
    }
  }
 return;
}
