#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include "mpi.h" 

int main(argc,argv)
int argc;
char *argv[];
{
    MPI_Comm icomm;
    int   nx, ny, nnx, nny,
      nu, np, *id, *ik, nd, sksize, *ikb, *idb,
      hmax,  iksize,i, zero, procx, procy, numprocs, myid,
      neigh[4], color;
    double xl, xr, yb, yt, *sk, dzero=0., *u, *f, *p, *g, *skb, *d, *h,
      omega, *massma, done = 1.;
    
 
    icomm = MPI_COMM_WORLD;
    MPI_Init(&argc,&argv);
    MPI_Comm_size(icomm,&numprocs);
    MPI_Comm_rank(icomm,&myid);
    if (myid == 0)
    {
       printf("\n There are %d processes running.\n \n",numprocs);
    }
    
    MPI_Barrier(icomm);

    procx = (int) sqrt((double) numprocs);
    procy = (int) sqrt((double) numprocs);

    if (procy * procx != numprocs) 
    {
      printf("\n Wrong number of processors !\n \n");
    }
    else
    {
      IniGeom(myid, procx, procy, neigh, &color);

      MPI_Barrier(icomm);
/*                                              subdomain coordinates */
      IniCoord(myid, procx, procy, &xl, &xr, &yb, &yt);

      /* number of intervals on (xl,xr)=:nx, (yb,yt)=:ny */
      nx = 5;
      ny = 6;
      /* number of nodes per direction (xl,xr)=nx+1=:nex, (yb,yt)=ny+1=:ney */
      nnx = nx + 1;
      nny = ny + 1;
      /* number of degrees of freedom  */
      nd = nnx*nny;
      
      /* allocate memory */
      u = (double *) malloc(nd*sizeof(dzero));          /* temperature */

      /* initialize u = 0 */
      for (i=0; i<nd; i++)
      	   u[i] = myid*100+i;

      DebugD(nd,u);
      
      VecAccu(nx,ny,u,neigh,color,myid,icomm);
      
      DebugD(nd,u);
      
      free(u);
  }
	       
  MPI_Finalize();
}

            
