/*			master and slave process			*/
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include "mpi.h"

int main(argc,argv)
int argc;
char *argv[];
{
    int myid, numprocs, IsMaster; 
    MPI_Comm icomm;

/*	Spawn processes							*/

    My_MPI_Init(argc,argv,&icomm); 
    
    MPI_Comm_size(icomm,&numprocs);
    MPI_Comm_rank(icomm,&myid);
    
    IsMaster = (myid==0);
 
/* 	Greetings from all nodes					*/

    greetings(myid,numprocs,icomm);

/*	Calculation							*/

    if (IsMaster){ calc_master(myid,numprocs,icomm); }
            else { calc_slave (myid,numprocs,icomm); }
   
    MPI_Finalize();

}

            
